; *******************************************************************************************************
; ******* 6 ventilaatori kiiruse regulaator FanBus	   									*****************
; ******* felc@edu.ttu.ee					    	 									*****************
; *******************************************************************************************************
; 31.10.: PWM ttab. Seriali pidi ksutamine simulaatoris kah. Reaalselt ei funksi:(
; 4.11.: ksutamine ja indikatsioon ttab, EEPROM samuti. Stardil max pinge ventidele 1s vltel!
; *******************************************************************************************************
	INCLUDE "P16F628.inc"
; ***** Definitsioonid ***** 
; ***** constaantsid *******
#define maxcmdlen		.3						; niimitut baiti+1 ootame
#define	framestart		'$'						; sidepaketi alguse char
#define	frameend		'*'						; sidepaketi lpu char
#define serialtime		.10						; umbes 10 mS
; ***** Raudwrk *********** 
#define LED0			PORTA,0					; nivooindikaatori LED (kige nrgema signaali jaoks)
#define LED1			PORTA,1					; nivooindikaatori LED 
#define LED2			PORTA,2					; nivooindikaatori LED 
#define LED3			PORTA,3					; nivooindikaatori LED 
#define LED4			PORTA,4					; nivooindikaatori LED 
;#define LED5			PORTA,5					; nivooindikaatori LED 
#define LED5			PORTA,6					; nivooindikaatori LED 
#define LED6			PORTA,7					; nivooindikaatori LED (kige tugevama signaali jaoks)

#define Data_in			PORTB,1					; RS_232 sisend kiiruste muutmiseks ja nivoo infoks
#define L_R				PORTB,0					; Kui 1, plevad vasaku kanali LEDid, kui 0, siis parema

#define FAN0			PORTB,2					; FAN 0 juhtimise vljund
#define FAN1			PORTB,3					; FAN 1 juhtimise vljund
#define FAN2			PORTB,4					; FAN 2 juhtimise vljund
#define FAN3			PORTB,5					; FAN 3 juhtimise vljund
#define FAN4			PORTB,6					; FAN 4 juhtimise vljund
#define FAN5			PORTB,7					; FAN 5 juhtimise vljund

; ***** varioossed lipud ***
#define CARRY           STATUS,C 
#define ZERO            STATUS,Z 
#define	pank			STATUS,RP0
#define	SerialTimerOn	flags,0
#define	SerialTimeOut	flags,1
#define	KaskOK			flags,2
#define	pakett			flags,3
#define	v_kanal			flags,4

; ***** aadressid EEPROMis **************          
#define E_FAN0	        	d'0'				;Vent 0 kiirus
#define E_FAN1	        	d'1'				
#define E_FAN2	        	d'2'				
#define E_FAN3	        	d'3'				
#define E_FAN4	        	d'4'				
#define E_FAN5	        	d'5'				



				errorlevel -302					; Compaileri vingumised ra
				errorlevel -305
				errorlevel -306 
; 	__CONFIG _INTRC_OSC_NOCLKOUT & _PWRTE_ON & _BODEN_ON & _MCLRE_OFF & _WDT_OFF & _CP_OFF    
	__CONFIG _WDT_OFF&_INTRC_OSC_NOCLKOUT&_PWRTE_ON&_CP_OFF&_MCLRE_OFF&_BODEN_ON&_LVP_OFF
	
; **** Muutujate definitsioonid *****    
RAMbase         equ     20h            
	cblock  	RAMbase                 
				flags  ;20               
				PWM0reg
				PWM1reg
				PWM2reg
				PWM3reg
				PWM4reg
				PWM5reg
				PWM0
				PWM1
				PWM2
				PWM3
				PWM4
				PWM5
				W_Temp
				S_Temp
				RxPointer
				bytecnt
				temp
				temp1
				temp2
				serialtimer
				Puhver
	endc 
				org H'2100' 					; kiiruste mingid lhtevrtused EEPROM is
				de 0x04							; FAN0 kiirus
				de 0x0D							; FAN1 kiirus
				de 0x08							; FAN2 kiirus
				de 0x0A							; FAN3 kiirus
				de 0x10							; FAN4 kiirus
				de 0x1A							; FAN5 kiirus

; ***** RESET **************          
				org     0000h  
				goto    Main_Start       		; ja hakkab pihta...
; *************************************************************************************************************
; ************************ KATKESTUSED ************************************************************************
; *************************************************************************************************************
Interrupt       org     0004h 
Push    		movwf   W_Temp           		; Seivi kontekst        
				swapf   STATUS,W         
				movwf   S_Temp     
				bcf     pank
Disable_Int         	
				bcf     INTCON,GIE       		; keela katckestused        
         
int_2:			btfsc   INTCON,T0IF      		; Taimer0 (ks periood lppes)?         
				goto    Timer0_Int        		; jah, alusta uut
int_3:			btfsc   PIR1,TMR2IF      		; Taimer2 (aeg kontrollida PWM-e)?         
				goto    Timer2_Int        		; jah
Pop     			
				swapf   S_Temp,W         
				movwf   STATUS           		; Return STATUS         
				swapf   W_Temp,F         
				swapf   W_Temp,W         		; Return W         
				retfie                   		; vlja siit, jta intsid lubatux (GIE  !)
; *************************************************************************************************************
; ************************ Taimer 2 int ***********************************************************************
; *************************************************************************************************************
; **** 1 PWM-i 42-st sammust lbi, kontrollime kas mni FAN tahab pinget maha saada				
Timer2_Int      bcf		PIR1,TMR2IF    			; katkestuse nue maha 
				clrf	TMR2					; snkroniseerime sammutaimeri T2
				decfsz	PWM0reg					; FAN0 pulss sai lbi?
				goto	T2_1					; ei
				bcf		FAN0					; jah, pinge maha
T2_1			decfsz	PWM1reg				
				goto	T2_2
				bcf		FAN1
T2_2			decfsz	PWM2reg				
				goto	T2_3
				bcf		FAN2
T2_3			decfsz	PWM3reg				
				goto	T2_4
				bcf		FAN3
T2_4			decfsz	PWM4reg				
				goto	T2_5
				bcf		FAN4
T2_5			decfsz	PWM5reg				
				goto	T2_6
				bcf		FAN5
T2_6:			goto	Pop
; *************************************************************************************************************
; ************************ Taimer 0 int ***********************************************************************
; *************************************************************************************************************
; **** ks PWM-ide periood lbi, alustame jrgmist	
Timer0_Int	    bcf		INTCON,T0IF    			; katkestuse nue maha 
				bcf		PIR1,TMR2IF
				clrf	TMR0					; ? tarbetu?
				clrf	TMR2					; snkroniseerime sammutaimeri T2
				movlw	0xFF
				movwf	PORTB					; ja ventidele pinge peale 
				bcf		L_R						; las nivooindikaatori toide jb igele kanalile peale
				btfss	v_kanal
				bsf		L_R						; taheti paremat nidata, teemegi nii! (juhtimine inversioonis!!!)
				movf	PWM0,W					; lae PWM-id uuesti
				movwf	PWM0reg
				movf	PWM1,W					
				movwf	PWM1reg
				movf	PWM2,W					
				movwf	PWM2reg
				movf	PWM3,W					
				movwf	PWM3reg
				movf	PWM4,W					
				movwf	PWM4reg
				movf	PWM5,W					
				movwf	PWM5reg
				btfss	SerialTimerOn			; kui ksk saabumas, kontrolli ka side taimerit
				goto	Pop
				decfsz	serialtimer				; seni OK
				goto	Pop		
				bcf		SerialTimerOn			; taimaut -> side viga
				bsf		SerialTimeOut
				bsf		pank
				bcf		PIE1,RCIE
				bcf		pank
				goto	Pop
; *************************************************************************************************************
; ************************ MAIN *******************************************************************************
; *************************************************************************************************************
Main_Start:		call	Init					; majapidamine korda
main_loop:      btfsc	SerialTimeOut			; ksk valesti vastu vetud (ji pooleli)?
				goto	kask_exit				; jah, nulli vastuvtt
				btfsc	PIR1,RCIF				; saime ksubaidi?
				call	SerInt					; jah, ttle teda
				btfss	KaskOK					; ksk OK ?
				goto	main_loop				; ei, tskelda edasi
kask_saadud:	movlw	Puhver					; loeme ksulaudu
				movwf	FSR
				movf	INDF,W
				sublw	'L'						; inditseeri nivood vasakus kanalis?
				btfsc	ZERO
				goto	vasak
				movf	INDF,W
				sublw	'R'						; inditseeri nivood paremas kanalis?
				btfsc	ZERO
				goto	parem
				movf	INDF,W
				sublw	'F'						; nita LED-del juhitava FANi numbrit?
				btfsc	ZERO
				goto	n_vent					; nitame numbrit (vastav LED helendab) vasakus kanalis
				movf	INDF,W
				sublw	'+'						; suurenda FAN-i kiirust?
				btfsc	ZERO
				goto	kiiremini
				movf	INDF,W
				sublw	'-'						; vhenda FAN-i kiirust?
				btfsc	ZERO
				goto	aeglasemalt
				movf	INDF,W
				sublw	'N'						; nita FAN-i kiirust?
				btfsc	ZERO
				goto	level_vent
				goto	kask_exit				; tundmatut ksku ignoreerime

n_vent:			incf	FSR						; loe vendi number [0..5]
				movf	INDF,W	
				call	fannumber				; konverdi LED-ide koodiks
				bsf		v_kanal					; nitame vaid vasakus kanalis
				bsf		L_R						; vasaku kanali LEDidele toide peale
				movwf	PORTA					; saada LEDidele
				goto	kask_exit

level_vent:		incf	FSR						; loe parameeter
				movlw	PWM0					; arvutame inditseritava FANi registri aadressi
				movwf	temp1
				movf	INDF,W
				addwf	temp1,W
				movwf	FSR
				movf	INDF,W					; loeme vrtuse vrtust
				call	fanlevel				; teisenda LEDide koodiks
				bsf		v_kanal					; nitame vaid vasakus kanalis
				bsf		L_R						; vasaku kanali LEDidele toide peale
				movwf	PORTA					; saada kood LEDidele
				goto	kask_exit

vasak:			incf	FSR						; loe parameeter
				movf	INDF,W
				movwf	PORTA					; juhi LED-e
				bsf		L_R						; vasaku kanali LEDidele toide peale
				bsf		v_kanal
				goto	kask_exit
parem:			incf	FSR						; loe parameeter
				movf	INDF,W
				movwf	PORTA					; juhi LED-e
				bcf		L_R						; parema kanali LEDidele toide peale
				bcf		v_kanal
				goto	kask_exit
kiiremini:
				incf	FSR						; loe parameeter
				movlw	PWM0					; arvutame juhitava FANi registri aadressi
				movwf	temp1
				movf	INDF,W
				movwf	temp2					; EEPROMi aadressi jaoks
				addwf	temp1,W
				movwf	FSR
				movf	INDF,W					; suurendame vrtust
				sublw	.42						; juba max?
				btfsc	ZERO
				goto	kask_exit				; jah, siis ei suurenda	
				movf	INDF,W					; taasta vrtus
				addlw	0x01
				movwf	INDF
				call	save_eeprom				; seivime 
				goto	kask_exit
aeglasemalt:	incf	FSR						; loe parameeter
				movlw	PWM0					; arvutame juhitava FANi registri aadressi
				movwf	temp1
				movf	INDF,W
				movwf	temp2					; EEPROMi aadressi jaoks
				addwf	temp1,W
				movwf	FSR
				movf	INDF,W					; juba min?
				movwf	temp1					
				movlw	0x01					
				subwf	temp1,W
				btfsc	ZERO
				goto	kask_exit				; jah, siis unustame ksu
				movf	INDF,W					; taasta vrtus
				movwf	temp1
				movlw	0x01					; vhendame
				subwf	temp1,W
				movwf	INDF
				call	save_eeprom				; seivime 
kask_exit:		movlw	Puhver					; nulli vastuvtt:
				movwf	RxPointer				; - puhvri pointer
				clrf	bytecnt					; - baitide loendi
				bcf		SerialTimeOut			; nullime vastuvtu taimeri
				bcf		SerialTimerOn	
				movlw	serialtime
				movwf	serialtimer
				bcf		KaskOK					; ksk tidetud...
				goto	main_loop
; *************************************************************************************************************
; ************************ Funkcioonid ************************************************************************
; *************************************************************************************************************

; *************************************************************************************************************
; ************************ salvestab kiiruse EEPROMi **********************************************************
; *************************************************************************************************************
save_eeprom:	bsf     pank 
				movwf	EEDATA
				bcf     pank 
				movf	temp2,W		 			; aadress
				bsf     pank 
save_eeprom_1:	movwf	EEADR	
				bcf		INTCON,GIE				; 
				bsf		EECON1,WREN				; luba kirjutamine
				movlw	55h						; lukust lahti
				movwf	EECON2
				movlw	0AAh
				movwf	EECON2
				bsf		EECON1,WR					
save_eeprom_2:			
				btfsc	EECON1,WR 				; ootame kirjutamise lppu
				goto	save_eeprom_2
				bcf		EECON1,WREN				; keela kirjutamine
				bcf     pank 
				bsf		INTCON,GIE				 
				return  
; *************************************************************************************************************
; ************************ loeb kiiruse EEPROMist '''**********************************************************
; *************************************************************************************************************
Read_eeprom:	bsf     pank
				movwf	EEADR					; aadress
				bsf		EECON1,RD			 	; loe!
				movf	EEDATA,W
				bcf     pank
				return  
; *************************************************************************************************************
; ************************ Seriali int ilma int'ita ;) ********************************************************
; *************************************************************************************************************
SerInt			bcf		PIR1,RCIF
				movlw	06h						; Maskeeri tarbetud bitid
				andwf	RCSTA,W					; viga?
				btfss	ZERO
				goto	RcvError				; Viga!
				movf	RxPointer,W				; lae puhvri pointer
				movwf	FSR
				movf	RCREG,W					; Geti input daata
				movwf	temp
				btfss	pakett					; kas algus juba leitud?
				goto	paketialgus				; ei veel, testime smbolit
				goto	paketilopp				; kki lpu mrk?
ser_save:		movf	temp,W
				movwf	INDF					; Seivi puhvrisse
				incf	RxPointer				; pointeri increment
				incf	bytecnt,F				; baitide arv +1
				movf	bytecnt,W 				; kik ksubaidid kes?
				sublw	maxcmdlen				
				btfsc	ZERO
				goto	RcvError				; kes aga saate lpu smbol puudub -> viga -> vesi peale ;)
				return
paketialgus:	sublw	framestart				; kas alguse smbol?
				btfss	ZERO	
				return							; ei , unustame jama...
				bsf		pakett					; jepp, alustame salvestamist
				bsf		SerialTimerOn			; kivitame taimeri mis annab viga kui 10mS mdas aga ksk ikka pooleli
				return
paketilopp:		sublw	frameend				; kas lpu smbol
				btfss	ZERO
				goto	ser_save				; ei, salvesta edasi
				bcf		pakett					; pakett lbi

kask_kaes		bsf		KaskOK					; mrgime et ksk kes 
RcvExit			movlw	Puhver					; nulli vastuvtt:
				movwf	RxPointer				; - puhvri pointer
				clrf	bytecnt					; - baitide loendi
				bcf		SerialTimeOut			; nullime vastuvtu taimeri
				bcf		SerialTimerOn	
				movlw	serialtime
				movwf	serialtimer
				return
					
RcvError:		movf	RCREG,W					; thjenda RCREG
				bcf		RCSTA,CREN				; reseti port
				bsf		RCSTA,CREN
				bcf		pakett					; pakett ka lbi
				goto	RcvExit	
; *************************************************************************************************************
; ************************ teeb fani kiiruse LEDide "bargraph'iks" ********************************************
; *************************************************************************************************************
fanlevel:		movwf	temp1					; ajutine seiv
				movlw	HIGH TabelF				; laeme pic-i aadressregistri igesti
				movwf	PCLATH
				movlw 	LOW TabelF
				addwf	temp1,W					; lisa offset
				call	TabelF					; saa otsitav LED-de kood
				return
; *************************************************************************************************************
; ************************ teeb fani numbri [0...5] LEDide koodiks" *******************************************
; *************************************************************************************************************
fannumber:		movwf	temp1					; ajutine seiv
				movlw	HIGH TabelN				; laeme pic-i aadressregistri igesti
				movwf	PCLATH
				movf	temp1,W					; offset
				call	TabelN					; saa otsitav LED-de kood
				return
; *************************************************************************************************************
; ************************ Init *******************************************************************************
; *************************************************************************************************************
; **** konf ****
Init:			bsf     pank
				movlw   b'00000010'         
				movwf   OPTION_REG      		; WPU-d lubatud, 1:8 prescaler T0-le, sisemine takt
				bcf     pank
				clrwdt
; **** pordid ****
				clrf	PORTA					; pordid nulli
				clrf	PORTB
				movlw 	07h 					; analoog komparaator vlja
				movwf 	CMCON 
				bsf     pank
				clrf 	TRISA 					; port A on vljund
				movlw	0x02					; port B-s on vaid RxD sisend, muud on vljundid
				movwf	TRISB
				bcf     pank
				movlw	0xFF					; portide lhteseisud 
				movwf 	PORTA 
				movlw	0x03					; portide lhteseisud 
				movwf 	PORTB 
; **** serialport ****
				bsf		pank		
				movlw	.51; 4800  .25						; baudrate = 9600
				movwf	SPBRG		
				movlw	B'00000100'				; saatja keelata
				movwf	TXSTA
				bcf		pank
				movlw	B'10010000'				; tavaline 8-bitine vastuvtt
				movwf	RCSTA
; **** Timer 2 ****
				clrf	T2CON					; Pre- ja postscalerid 1:1, taimer seisma
				clrf	TMR2					; taimer nullida
				bsf		pank	
				movlw	.32						; katkestus iga 32 uS tagant (1 PWM'i samm)
				movwf	PR2
				bcf		pank
; **** Timer 1 ja 0,5s max pinget ventidele stardi hlbustamiseks ****
				movlw	0xFF					; ventidele max pinged peale
				movwf 	PORTB 
				movlw	0x00					; ootame 0,5s
				movwf	TMR1L
				movlw	0x00
				movwf	TMR1H
				movlw	b'00110101'				; 1/8 prescaler, int osc, kima
				movwf	T1CON
				bcf		PIR1,TMR1IF				; letit. lipp
_1sviide:		btfss	PIR1,TMR1IF
				goto	_1sviide
				bcf		PIR1,TMR1IF				; veelkord 0,5s
_2sviide:		btfss	PIR1,TMR1IF
				goto	_2sviide
				bcf		PIR1,TMR1IF				; letit. lipp
				bcf		T1CON,TMR1ON
; **** variaablid ****
				clrf	flags
				movlw	E_FAN0					; loe EEPROMist kiirused ja rakenda
				call	Read_eeprom
				movwf	PWM0	      		
				movwf	PWM0reg
				movlw	E_FAN1					
				call	Read_eeprom
				movwf	PWM1	      		
				movwf	PWM1reg
				movlw	E_FAN2					
				call	Read_eeprom
				movwf	PWM2	      		
				movwf	PWM2reg
				movlw	E_FAN3					
				call	Read_eeprom
				movwf	PWM3	      		
				movwf	PWM3reg
				movlw	E_FAN4					
				call	Read_eeprom
				movwf	PWM4	      		
				movwf	PWM4reg
				movlw	E_FAN5					
				call	Read_eeprom
				movwf	PWM5	      		
				movwf	PWM5reg
; seriali vastuvtu suurused
				movlw	Puhver					; nulli vastuvtt:
				movwf	RxPointer				; - puhvri pointer
				clrf	bytecnt					; - baitide loendi
				bcf		SerialTimeOut			; nullime vastuvtu taimeri
				bcf		SerialTimerOn	
				movlw	serialtime
				movwf	serialtimer
;				bsf		pank
;				bsf		PIE1,RCIE
;				bcf		pank
; **** ventidele pinged peale ****
				movlw	0xFF
				movwf	PORTB					; ja ventidele pinge peale 
; **** katkestused ****
				bcf		INTCON,T0IF				; T0 katkestuse nue maha
				bsf		INTCON,T0IE				; katkestus lubada
				bcf		PIR1,TMR2IF				; T2 katkestuse nue maha
				bsf		pank
				bsf		PIE1,TMR2IE				; katkestus lubada
				bcf		pank
				bsf		INTCON,PEIE				; luba peripheral intsid
; **** lubame intsid ****
				bsf		T2CON,TMR2ON			; sammu taimer kima
				clrf	TMR0					; snkroniseeri perioodi taimer
				bsf		INTCON,GIE				; lubame katkestused
    			return  
; *************************************************************************************************************
; ************************ muu jama ***************************************************************************
; *************************************************************************************************************
				org		0300
TabelF:			addwf	PCL,F					; LEDide koodid FAN-i kiiruse inditseerimiseks
				retlw	0xFF					; kiirus minimaalne, kski LED ei ple
				retlw	0xFF
				retlw	0xFF
				retlw	0xFF
				retlw	0xFF
				retlw	0xFF

				retlw	0xFE					; 1. samm
				retlw	0xFE
				retlw	0xFE
				retlw	0xFE
				retlw	0xFE
				retlw	0xFE

				retlw	0xFC					; 2. samm
				retlw	0xFC
				retlw	0xFC
				retlw	0xFC
				retlw	0xFC
				retlw	0xFC

				retlw	0xF8					; 3. samm
				retlw	0xF8
				retlw	0xF8
				retlw	0xF8
				retlw	0xF8
				retlw	0xF8

				retlw	0xF0					; 4. samm
				retlw	0xF0
				retlw	0xF0
				retlw	0xF0
				retlw	0xF0
				retlw	0xF0

				retlw	0xE0					; 5. samm
				retlw	0xE0
				retlw	0xE0
				retlw	0xE0
				retlw	0xE0
				retlw	0xE0

				retlw	0xA0					; 6. samm. Jtame A5 tuleviku tarbeks krgeks, see on AINULT sisendotc
				retlw	0xA0
				retlw	0xA0
				retlw	0xA0
				retlw	0xA0
				retlw	0xA0

				retlw	0x20					; 7. samm. Jtame A5 tuleviku tarbeks krgeks, see on AINULT sisendotc 
				retlw	0x20
				retlw	0x20
				retlw	0x20					
				retlw	0x20			
				retlw	0x20			
; *************************************************************************************************************
TabelN:			addwf	PCL,F					; LEDide koodid FAN-i numbri inditseerimiseks 
				retlw	0xFE					; Fan 0 - pleb vasakult esimene LED
				retlw	0xFD					; Fan 1 - pleb vasakult teine LED jne
				retlw	0xFB					; Fan 2
				retlw	0xF7					; Fan 3
				retlw	0xEF					; Fan 4
				retlw	0xBF					; Fan 5 NB! PORTA,5 ei ole kasutatav vljundina, seeprast BF, mitte DF.
	END  
